#pragma once

typedef enum _BurnerErrorState
{
    NO_ERROR,
    FAULT
} eBurnerErrorState;

typedef enum _MeasurementMode
{
    CURRENT,
    AVERAGE_10S,
    AVERAGE_60S
} eMeasurementMode;

void initInputs(void);
float getChamberTemperature(eMeasurementMode mode);
float getOutdoorTemperature(eMeasurementMode mode);
float getInletFlowTemperature(eMeasurementMode mode);
float getReturnFlowTemperature(eMeasurementMode mode);
eBurnerErrorState getBurnerError(void);