#pragma once

#include "outputs.h"
#include "inputs.h"

#define MAX_ERROR_STRING_SIZE 64U
#define NUMBER_OF_SENSOR_SANITY_CHECKS 4U

typedef float (*GetSensorValue)(eMeasurementMode);
typedef struct _TemperatureSensorLimit
{
    float max; // Maximum temperature limit
    float min; // Minimum temperature limit
} sTemperatureSensorLimit;
typedef struct _SensorSanityCheck
{
    uint8_t status;
    char name[MAX_ERROR_STRING_SIZE];
    sTemperatureSensorLimit sSensorLimit;
    float fSensorTemperatureLast;
    uint32_t uUnchangedCounter;
    GetSensorValue getSensor;
} sSensorSanityCheck;

void initSafety(void);

//sSensorSanityCheck *getSafetyStates(void);